#!/usr/local/bin/perl5 -w

$MAINTAINER
='<a href="mailto:steve@genome.wi.mit.edu">steve@genome.wi.mit.edu</a>';
%SEQ_LIBRARY=
	('NONE' => '',  # Put more repeat libraries here, e.g.
	#'HUMAN' => '/usr/local/lib/repbase/humrep_and_simple.fasta',
	);

$Copyright = q{ 
 Copyright (c) 1996,1997
        Whitehead Institute for Biomedical Research. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1.      Redistributions must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the  documentation
and/or other materials provided with the distribution.  Redistributions of
source code must also reproduce this information in the source code itself.

2.      If the program is modified, redistributions must include a notice
(in the same places as above) indicating that the redistributed program is
not identical to the version distributed by Whitehead Institute.

3.      All advertising materials mentioning features or use of this
software  must display the following acknowledgment:
        This product includes software developed by the
        Whitehead Institute for Biomedical Research.

4.      The name of the Whitehead Institute may not be used to endorse or
promote products derived from this software without specific prior written
permission.

We also request that use of this software be cited in publications as 

Steve Rozen, Helen J. Skaletsky (1996,1997)
   Primer3. Code available at
   http://www-genome.wi.mit.edu/genome_software/other/primer3.html

THIS SOFTWARE IS PROVIDED BY THE WHITEHEAD INSTITUTE ``AS IS'' AND  ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE  IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE  ARE
DISCLAIMED. IN NO EVENT SHALL THE WHITEHEAD INSTITUTE BE LIABLE  FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL  DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS  OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)  HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
};

BEGIN{
    print "Content-type: text/html\n\n";
    open(STDERR, ">&STDOUT");
    $| = 1;
    print '';
}
use CGI;

$cgi_version = "(primer3.cgi v 0.2a)";
$logo = '';
# $logo = '<img src="/www/wilogo.gif" alt="[Whitehead Logo]">';

$PRIMER_BIN =  './primer3';

$PRIMER_SEQUENCE_ID                       = "";
$SEQUENCE                                 = "";
$INCLUDED_REGION                          = "";
$TARGET                                   = "";
$EXCLUDED_REGION                          = "";
$PRIMER_SEQUENCE_QUALITY                  = "";
$PRIMER_LEFT_INPUT                        = "";
$PRIMER_RIGHT_INPUT                       = "";
$PRIMER_MAX_MISPRIMING                    = "12.00";
$PRIMER_PAIR_MAX_MISPRIMING               = "24.00";
$PRIMER_PRODUCT_SIZE_RANGE                = "100-300";
$PRIMER_GC_CLAMP                          = "0";
$PRIMER_OPT_SIZE                          = "20";
$PRIMER_MIN_SIZE                          = "18";
$PRIMER_MAX_SIZE                          = "27";
$PRIMER_OPT_TM                            = "60.0";
$PRIMER_MIN_TM                            = "57.0";
$PRIMER_MAX_TM                            = "63.0";
$PRIMER_MAX_DIFF_TM                       = "100.0";
$PRIMER_MIN_GC                            = "20.0";
$PRIMER_MAX_GC                            = "80.0";
$PRIMER_SALT_CONC                         = "50.0";
$PRIMER_DNA_CONC                          = "50.0";
$PRIMER_NUM_NS_ACCEPTED                   = "0";
$PRIMER_SELF_ANY                          = "8.00";
$PRIMER_SELF_END                          = "3.00";
$PRIMER_MAX_POLY_X                        = "5";
$PRIMER_NUM_RETURN                        = "5";
$PRIMER_FIRST_BASE_INDEX                  = "1";
$PRIMER_MIN_QUALITY                       = "0";
$PRIMER_MIN_END_QUALITY                   = "0";
$PRIMER_QUALITY_RANGE_MIN                 = "0";
$PRIMER_QUALITY_RANGE_MAX                 = "100";
$PRIMER_INSIDE_PENALTY                    = "-1.0";
$PRIMER_OUTSIDE_PENALTY                   = "0.0";
$PRIMER_MAX_END_STABILITY                 = "100.0";
$PRIMER_INTERNAL_OLIGO_EXCLUDED_REGION    = "";
$PRIMER_INTERNAL_OLIGO_INPUT              = "";
$PRIMER_INTERNAL_OLIGO_OPT_SIZE           = "20";
$PRIMER_INTERNAL_OLIGO_MIN_SIZE           = "18";
$PRIMER_INTERNAL_OLIGO_MAX_SIZE           = "27";
$PRIMER_INTERNAL_OLIGO_OPT_TM             = "60.0";
$PRIMER_INTERNAL_OLIGO_MIN_TM             = "57.0";
$PRIMER_INTERNAL_OLIGO_MAX_TM             = "63.0";
$PRIMER_INTERNAL_OLIGO_MIN_GC             = "20.0";
$PRIMER_INTERNAL_OLIGO_MAX_GC             = "80.0";
$PRIMER_INTERNAL_OLIGO_SALT_CONC          = "50.0";
$PRIMER_INTERNAL_OLIGO_DNA_CONC           = "50.0";
$PRIMER_INTERNAL_OLIGO_SELF_ANY           = "12.00";
$PRIMER_INTERNAL_OLIGO_MAX_POLY_X         = "5";
$PRIMER_INTERNAL_OLIGO_SELF_END           = "12.00";
$PRIMER_INTERNAL_OLIGO_MAX_MISHYB         = "12.00";
$PRIMER_INTERNAL_OLIGO_MIN_QUALITY        = "0";

$query = new CGI;

unless (defined $query->param('Pick Primers')) {
    get_input($query);
} else {
    process_input($query);
}

sub process_input {
    my ($query) = @_;
    my $wrapup = $query->end_html;
    my $tmpurl = $query->url;
    my ($v, $v1);
    print $query->start_html("Primer3 Output $cgi_version");
    print qq{<h2>$logo Primer3 Output</h2>\n};
    print "<hr>\n";
    my @names = $query->param;
    unless (-e $PRIMER_BIN) {
	print qq{Please contact webmaster: cannot find $PRIMER_BIN executable
		     $wrapup};
	return;
    }
    unless (-x $PRIMER_BIN) {
	print qq{Please contact webmaster: wrong permissions for $PRIMER_BIN
		     $wrapup};
	return;
    }

    # Check mispriming / mishyb library setup.
    for (@names) {
	if (/^PRIMER_(MISPRIMING|INTERNAL_OLIGO_MISHYB)_LIBRARY$/) {
	    $v = $query->param($_);
	    $v1 = $SEQ_LIBRARY{'$v'};
	    if (!defined($v)) {
		print qq{
		    <h3>There is a configuration error at $tmpurl;
		    cannot find a library file name for  "$v1".  Please clip and
		    mail this page to $MAINTAINER.$wrapup</h3>
			};
		return;
	    }
	    if ($v1 && ! -r $v1) {
		print qq{
		    <h3>There is a configuration error at $tmpurl;
		    library file  $v1 cannot be read.  Please clip and
		    mail this page to $MAINTAINER.$wrapup</h3>
		    };
		return;

	    }
	}
    }

    my $cmd = "$PRIMER_BIN -format_output -strict_tags";
    my ($line, $v);
    if (!open(PRIMER,"| $cmd")) {
	print "Cannot execute <pre>$cmd\n</pre>\n$wrapup";
	return;
    }
    print "<pre>\n";

    print PRIMER "PRIMER_EXPLAIN_FLAG=1\n";

    for (@names) {
	next if /^Pick Primers$/;
	$v = $query->param($_);
	next if $v =~ /^\s*$/;
	$v =~ s/\s//g if /^SEQUENCE$/;
	$v = $SEQ_LIBRARY{$v}
	    if /^PRIMER_(MISPRIMING|INTERNAL_OLIGO_MISHYB)_LIBRARY$/;
	$line = "$_=$v\n";
	print PRIMER $line;

    }
    print PRIMER "=\n";
    close PRIMER;
    print "</pre>\n";
    if ($? != 0 && $? != 64512) { # 64512 == -4
        my $tmpnames = join("\n", @names);
        my $tmpurl = $query->url;
        print qq{
        <h3>Please clip and mail this page (including any
        information above this line) to $MAINTAINER (deleting your
        input sequence if you wish).</h3>
        <p>
	<h3>There is a configuration error or
        an unexpected internal error in the primer3 program at
        $tmpurl</h3>
        <p>
        <h3>The child process for primer3 was reaped with a non-0 termination
        status of $?.</h3>
        <p>
        <pre>
        \n};
	for (@names) {
	    next if /^Pick Primers$/;
	    $v = $query->param($_);
	    next if $v =~ /^\s*$/;
	    $v =~ s/\s//g if /^SEQUENCE$/;
	    $line = "$_=$v\n";
	    print $line;
	}
        print "</pre>\n"
    }
    
    print "$wrapup\n";
}

sub get_input {
    my ($query) = @_;
    print $query->start_html("Primer3 Input $cgi_version");

    # The '/results_from_primer3' is needed if users are
    # to easily print the output page from Netscape.
    my $process_input_url = $query->url . '/results_from_primer3';
    
    print qq{

<H1>$logo<a name="top">
Primer3</H1></a>
Pick PCR primers from nucleotide sequence (string of ATGCN, upper or lower case; other non-whitespace letters are treated as 'N').
<p>
<strong>Please see the
<a href="#disclaimer">Copyright Notice and Disclaimer.</a></strong>
Please send bug reports and suggestions to
<a href="mailto:primer3\@genome.wi.mit.edu">primer3\@genome.wi.mit.edu;</a>
<a href="http://www.genome.wi.mit.edu/genome_software/other/primer3.html">
source code is available.</a>
<p>
You can now specify a
<a href="#PRIMER_MISPRIMING_LIBRARY_INPUT">
library of sequences to avoid</a> and a 
<a href="#PRIMER_MAX_MISPRIMING_INPUT">maximum
similarity score for oligo matches to this library,
</a>
but by <em>default</em> Primer3 does <em>not</em> screen for 
undesirable sequence.
Please pre-screen your input sequence 
or use a <a href="#PRIMER_MISPRIMING_LIBRARY_INPUT">Mispriming Library</a>
selection as appropriate.
Sequence quality is also an important factor that Primer3 cannot
assess unless you supply appropriate input.
See <strong><a href=#cautions>Cautions.</a></strong>
</p>

<form action="$process_input_url" 
      method="post" 
      enctype="x-www-form-urlencoded">

<a href="#SEQUENCE">Paste source sequence below:</a><br>
<textarea name="SEQUENCE" rows=6 cols=70 value="$SEQUENCE"></textarea>
<p>

<input type="submit" name="Pick Primers" value="Pick Primers">
<font size="+1"><strong><a href="#cannot_find">What if no primers are found?</a></strong></font>
<input type="reset" value="Clear Form">
<P>


<h3><a name="Per-Sequence+Inputs">Per-Sequence Inputs</a></h3>

<table border=2>
<tr><td><a name=PRIMER_SEQUENCE_ID_INPUT href="#PRIMER_SEQUENCE_ID">Sequence Id:</a></td><td><input type="text" name=PRIMER_SEQUENCE_ID value=$PRIMER_SEQUENCE_ID>
</td></tr>
<tr><td><a name=INCLUDED_REGION_INPUT href="#INCLUDED_REGION">Included Region:</a></td><td><input type="text" name=INCLUDED_REGION value=$INCLUDED_REGION>
</td></tr>
<tr><td><a name=TARGET_INPUT href="#TARGET">Target:</a></td><td><input type="text" name=TARGET value=$TARGET>
</td></tr>
<tr><td><a name=EXCLUDED_REGION_INPUT href="#EXCLUDED_REGION">Excluded Region:</a></td><td><input type="text" name=EXCLUDED_REGION value=$EXCLUDED_REGION>
</td></tr>
<tr><td><a name=PRIMER_SEQUENCE_QUALITY_INPUT href="#PRIMER_SEQUENCE_QUALITY">Sequence Quality:</a></td><td><input type="text" name=PRIMER_SEQUENCE_QUALITY value=$PRIMER_SEQUENCE_QUALITY>
</td></tr>
<tr><td><a name=PRIMER_LEFT_INPUT_INPUT href="#PRIMER_LEFT_INPUT">Left Input:</a></td><td><input type="text" name=PRIMER_LEFT_INPUT value=$PRIMER_LEFT_INPUT>
</td></tr>
<tr><td><a name=PRIMER_RIGHT_INPUT_INPUT href="#PRIMER_RIGHT_INPUT">Right Input:</a></td><td><input type="text" name=PRIMER_RIGHT_INPUT value=$PRIMER_RIGHT_INPUT>
</td></tr>

</table>

<h3><a name="Global+Parameters">Global Parameters</a></h3>

		       <input type="checkbox" name=PRIMER_PICK_INTERNAL_OLIGO value=1>
			   <a name=PRIMER_PICK_INTERNAL_OLIGO_IN
                              href="#PRIMER_PICK_INTERNAL_OLIGO">Pick Internal Oligo</a>
			       <input
                                   type="checkbox" name=PRIMER_LIBERAL_BASE value=1 checked>
				   <a  name=PRIMER_LIBERAL_BASE_INPUT 
                                       href="#PRIMER_LIBERAL_BASE">Liberal Base</a><br>
				   
<table border=2>
<tr><td><a name=PRIMER_MISPRIMING_LIBRARY_INPUT href="#PRIMER_MISPRIMING_LIBRARY">Mispriming Library:</a></td><td><select name=PRIMER_MISPRIMING_LIBRARY>
<option selected>NONE
</select>
</td></tr>
<tr><td><a name=PRIMER_MAX_MISPRIMING_INPUT href="#PRIMER_MAX_MISPRIMING">Max Mispriming:</a></td><td><input type="text" name=PRIMER_MAX_MISPRIMING value=$PRIMER_MAX_MISPRIMING>
</td></tr>
<tr><td><a name=PRIMER_PAIR_MAX_MISPRIMING_INPUT href="#PRIMER_PAIR_MAX_MISPRIMING">Pair Max Mispriming:</a></td><td><input type="text" name=PRIMER_PAIR_MAX_MISPRIMING value=$PRIMER_PAIR_MAX_MISPRIMING>
</td></tr>
<tr><td><a name=PRIMER_PRODUCT_SIZE_RANGE_INPUT href="#PRIMER_PRODUCT_SIZE_RANGE">Product Size Range:</a></td><td><input type="text" name=PRIMER_PRODUCT_SIZE_RANGE value=$PRIMER_PRODUCT_SIZE_RANGE>
</td></tr>
<tr><td><a name=PRIMER_GC_CLAMP_INPUT href="#PRIMER_GC_CLAMP">CG Clamp:</a></td><td><input type="text" name=PRIMER_GC_CLAMP value=$PRIMER_GC_CLAMP>
</td></tr>
<tr><td><a name=PRIMER_OPT_SIZE_INPUT href="#PRIMER_OPT_SIZE">Optimum Primer Size:</a></td><td><input type="text" name=PRIMER_OPT_SIZE value=$PRIMER_OPT_SIZE>
</td></tr>
<tr><td><a name=PRIMER_MIN_SIZE_INPUT href="#PRIMER_MIN_SIZE">Minimum Primer Size:</a></td><td><input type="text" name=PRIMER_MIN_SIZE value=$PRIMER_MIN_SIZE>
</td></tr>
<tr><td><a name=PRIMER_MAX_SIZE_INPUT href="#PRIMER_MAX_SIZE">Maximum Primer Size:</a></td><td><input type="text" name=PRIMER_MAX_SIZE value=$PRIMER_MAX_SIZE>
</td></tr>
<tr><td><a name=PRIMER_OPT_TM_INPUT href="#PRIMER_OPT_TM">Optimum Tm:</a></td><td><input type="text" name=PRIMER_OPT_TM value=$PRIMER_OPT_TM>
</td></tr>
<tr><td><a name=PRIMER_MIN_TM_INPUT href="#PRIMER_MIN_TM">Minimum Tm:</a></td><td><input type="text" name=PRIMER_MIN_TM value=$PRIMER_MIN_TM>
</td></tr>
<tr><td><a name=PRIMER_MAX_TM_INPUT href="#PRIMER_MAX_TM">Maximum Tm:</a></td><td><input type="text" name=PRIMER_MAX_TM value=$PRIMER_MAX_TM>
</td></tr>
<tr><td><a name=PRIMER_MAX_DIFF_TM_INPUT href="#PRIMER_MAX_DIFF_TM">Maximum Tm Difference:</a></td><td><input type="text" name=PRIMER_MAX_DIFF_TM value=$PRIMER_MAX_DIFF_TM>
</td></tr>
<tr><td><a name=PRIMER_MIN_GC_INPUT href="#PRIMER_MIN_GC">Minimum GC Content:</a></td><td><input type="text" name=PRIMER_MIN_GC value=$PRIMER_MIN_GC>
</td></tr>
<tr><td><a name=PRIMER_MAX_GC_INPUT href="#PRIMER_MAX_GC">Maximum GC Content:</a></td><td><input type="text" name=PRIMER_MAX_GC value=$PRIMER_MAX_GC>
</td></tr>
<tr><td><a name=PRIMER_SALT_CONC_INPUT href="#PRIMER_SALT_CONC">Salt Concentration:</a></td><td><input type="text" name=PRIMER_SALT_CONC value=$PRIMER_SALT_CONC>
</td></tr>
<tr><td><a name=PRIMER_DNA_CONC_INPUT href="#PRIMER_DNA_CONC">Annealing Oligo Concentration:</a></td><td><input type="text" name=PRIMER_DNA_CONC value=$PRIMER_DNA_CONC>
</td></tr>
<tr><td><a name=PRIMER_NUM_NS_ACCEPTED_INPUT href="#PRIMER_NUM_NS_ACCEPTED">Maximum Ns Accepted:</a></td><td><input type="text" name=PRIMER_NUM_NS_ACCEPTED value=$PRIMER_NUM_NS_ACCEPTED>
</td></tr>
<tr><td><a name=PRIMER_SELF_ANY_INPUT href="#PRIMER_SELF_ANY">Maximum Complementarity:</a></td><td><input type="text" name=PRIMER_SELF_ANY value=$PRIMER_SELF_ANY>
</td></tr>
<tr><td><a name=PRIMER_SELF_END_INPUT href="#PRIMER_SELF_END">Maximum 3' Complementarity:</a></td><td><input type="text" name=PRIMER_SELF_END value=$PRIMER_SELF_END>
</td></tr>
<tr><td><a name=PRIMER_MAX_POLY_X_INPUT href="#PRIMER_MAX_POLY_X">Maximum Poly-X:</a></td><td><input type="text" name=PRIMER_MAX_POLY_X value=$PRIMER_MAX_POLY_X>
</td></tr>
<tr><td><a name=PRIMER_NUM_RETURN_INPUT href="#PRIMER_NUM_RETURN">Number To Return:</a></td><td><input type="text" name=PRIMER_NUM_RETURN value=$PRIMER_NUM_RETURN>
</td></tr>
<tr><td><a name=PRIMER_FIRST_BASE_INDEX_INPUT href="#PRIMER_FIRST_BASE_INDEX">First Base Index:</a></td><td><input type="text" name=PRIMER_FIRST_BASE_INDEX value=$PRIMER_FIRST_BASE_INDEX>
</td></tr>
<tr><td><a name=PRIMER_MIN_QUALITY_INPUT href="#PRIMER_MIN_QUALITY">Min Quality:</a></td><td><input type="text" name=PRIMER_MIN_QUALITY value=$PRIMER_MIN_QUALITY>
</td></tr>
<tr><td><a name=PRIMER_MIN_END_QUALITY_INPUT href="#PRIMER_MIN_END_QUALITY">Min End Quality:</a></td><td><input type="text" name=PRIMER_MIN_END_QUALITY value=$PRIMER_MIN_END_QUALITY>
</td></tr>
<tr><td><a name=PRIMER_QUALITY_RANGE_MIN_INPUT href="#PRIMER_QUALITY_RANGE_MIN">Quality Range Min:</a></td><td><input type="text" name=PRIMER_QUALITY_RANGE_MIN value=$PRIMER_QUALITY_RANGE_MIN>
</td></tr>
<tr><td><a name=PRIMER_QUALITY_RANGE_MAX_INPUT href="#PRIMER_QUALITY_RANGE_MAX">Quality Range Max:</a></td><td><input type="text" name=PRIMER_QUALITY_RANGE_MAX value=$PRIMER_QUALITY_RANGE_MAX>
</td></tr>
<tr><td><a name=PRIMER_INSIDE_PENALTY_INPUT href="#PRIMER_INSIDE_PENALTY">Inside Penalty:</a></td><td><input type="text" name=PRIMER_INSIDE_PENALTY value=$PRIMER_INSIDE_PENALTY>
</td></tr>
<tr><td><a name=PRIMER_OUTSIDE_PENALTY_INPUT href="#PRIMER_OUTSIDE_PENALTY">Outside Penalty:</a></td><td><input type="text" name=PRIMER_OUTSIDE_PENALTY value=$PRIMER_OUTSIDE_PENALTY>
</td></tr>
<tr><td><a name=PRIMER_MAX_END_STABILITY_INPUT href="#PRIMER_MAX_END_STABILITY">Max End Stability:</a></td><td><input type="text" name=PRIMER_MAX_END_STABILITY value=$PRIMER_MAX_END_STABILITY>
</td></tr>

</table>

<h3><a name="Internal+Oligo+Per-Sequence+Inputs">Internal Oligo Per-Sequence Inputs</a></h3>

<table border=2>
<tr><td><a name=internal_oligo_generic_INPUT href="#internal_oligo_generic">Internal Oligo Excluded Region:</a></td><td><input type="text" name=PRIMER_INTERNAL_OLIGO_EXCLUDED_REGION value=$PRIMER_INTERNAL_OLIGO_EXCLUDED_REGION>
</td></tr>
<tr><td><a name=internal_oligo_generic_INPUT href="#internal_oligo_generic">Internal Oligo Input:</a></td><td><input type="text" name=PRIMER_INTERNAL_OLIGO_INPUT value=$PRIMER_INTERNAL_OLIGO_INPUT>
</td></tr>

</table>

<h3><a name="Internal+Oligo+Global+Parameters">Internal Oligo Global Parameters</a></h3>

<table border=2>
<tr><td><a name=internal_oligo_generic_INPUT href="#internal_oligo_generic">Internal Oligo Optimum Size:</a></td><td><input type="text" name=PRIMER_INTERNAL_OLIGO_OPT_SIZE value=$PRIMER_INTERNAL_OLIGO_OPT_SIZE>
</td></tr>
<tr><td><a name=internal_oligo_generic_INPUT href="#internal_oligo_generic">Internal Oligo Minimum Size:</a></td><td><input type="text" name=PRIMER_INTERNAL_OLIGO_MIN_SIZE value=$PRIMER_INTERNAL_OLIGO_MIN_SIZE>
</td></tr>
<tr><td><a name=internal_oligo_generic_INPUT href="#internal_oligo_generic">Internal Oligo Maximum Size:</a></td><td><input type="text" name=PRIMER_INTERNAL_OLIGO_MAX_SIZE value=$PRIMER_INTERNAL_OLIGO_MAX_SIZE>
</td></tr>
<tr><td><a name=internal_oligo_generic_INPUT href="#internal_oligo_generic">Internal Oligo Optimum Tm:</a></td><td><input type="text" name=PRIMER_INTERNAL_OLIGO_OPT_TM value=$PRIMER_INTERNAL_OLIGO_OPT_TM>
</td></tr>
<tr><td><a name=internal_oligo_generic_INPUT href="#internal_oligo_generic">Internal Oligo Minimum Tm:</a></td><td><input type="text" name=PRIMER_INTERNAL_OLIGO_MIN_TM value=$PRIMER_INTERNAL_OLIGO_MIN_TM>
</td></tr>
<tr><td><a name=internal_oligo_generic_INPUT href="#internal_oligo_generic">Internal Oligo Maximum Tm:</a></td><td><input type="text" name=PRIMER_INTERNAL_OLIGO_MAX_TM value=$PRIMER_INTERNAL_OLIGO_MAX_TM>
</td></tr>
<tr><td><a name=internal_oligo_generic_INPUT href="#internal_oligo_generic">Internal Oligo Minimum GC Content:</a></td><td><input type="text" name=PRIMER_INTERNAL_OLIGO_MIN_GC value=$PRIMER_INTERNAL_OLIGO_MIN_GC>
</td></tr>
<tr><td><a name=internal_oligo_generic_INPUT href="#internal_oligo_generic">Internal Oligo Maximum GC Content:</a></td><td><input type="text" name=PRIMER_INTERNAL_OLIGO_MAX_GC value=$PRIMER_INTERNAL_OLIGO_MAX_GC>
</td></tr>
<tr><td><a name=internal_oligo_generic_INPUT href="#internal_oligo_generic">Internal Oligo Salt Concentration:</a></td><td><input type="text" name=PRIMER_INTERNAL_OLIGO_SALT_CONC value=$PRIMER_INTERNAL_OLIGO_SALT_CONC>
</td></tr>
<tr><td><a name=internal_oligo_generic_INPUT href="#internal_oligo_generic">Internal Oligo DNA Concentration:</a></td><td><input type="text" name=PRIMER_INTERNAL_OLIGO_DNA_CONC value=$PRIMER_INTERNAL_OLIGO_DNA_CONC>
</td></tr>
<tr><td><a name=internal_oligo_generic_INPUT href="#internal_oligo_generic">Internal Oligo Self Complementarity:</a></td><td><input type="text" name=PRIMER_INTERNAL_OLIGO_SELF_ANY value=$PRIMER_INTERNAL_OLIGO_SELF_ANY>
</td></tr>
<tr><td><a name=internal_oligo_generic_INPUT href="#internal_oligo_generic">Internal Oligo Maximum Poly-X:</a></td><td><input type="text" name=PRIMER_INTERNAL_OLIGO_MAX_POLY_X value=$PRIMER_INTERNAL_OLIGO_MAX_POLY_X>
</td></tr>
<tr><td><a name=internal_oligo_generic_INPUT href="#internal_oligo_generic">Internal Oligo Maximum 3' Self Complementarity:</a></td><td><input type="text" name=PRIMER_INTERNAL_OLIGO_SELF_END value=$PRIMER_INTERNAL_OLIGO_SELF_END>
</td></tr>
<tr><td><a name=internal_oligo_generic_INPUT href="#internal_oligo_generic">Internal Oligo Mishyb Library:</a></td><td><select name=PRIMER_INTERNAL_OLIGO_MISHYB_LIBRARY>
<option selected>NONE
</select>
</td></tr>
<tr><td><a name=internal_oligo_generic_INPUT href="#internal_oligo_generic">Internal Oligo Max Mishyb:</a></td><td><input type="text" name=PRIMER_INTERNAL_OLIGO_MAX_MISHYB value=$PRIMER_INTERNAL_OLIGO_MAX_MISHYB>
</td></tr>
<tr><td><a name=internal_oligo_generic_INPUT href="#internal_oligo_generic">Internal Oligo Min Quality:</a></td><td><input type="text" name=PRIMER_INTERNAL_OLIGO_MIN_QUALITY value=$PRIMER_INTERNAL_OLIGO_MIN_QUALITY>
</td></tr>

</table>


<dl>


<dt><a name="PRIMER_SEQUENCE_ID"><strong>Sequence Id</strong></a>
<dd>
An identifier that is reproduced in the output to enable users to
identify the source of the chosen primers.



<dt><a name="SEQUENCE"><strong>Sequence</strong></a>
<dd>The sequence from which to choose primers.  The sequence must be
presented 5' -> 3' (see the discussion of the 3'
self-complementarity parameters).  The bases may be upper or
lower case.  Whitespace characters are ignored, and any other
unrecognized character is treated as N.


<dt><a name="INCLUDED_REGION"><strong>Included Region</strong></a>
<dd>A sub-region of the given sequence in which to pick primers.  For
example, often the first dozen or so bases of a sequence are
vector, and should be excluded from consideration. The value for
this parameter has the form

<pre>
&ltstart&gt,&ltlength&gt
</pre>

where &ltstart&gt is the 0-based index of the first base to consider,
and &ltlength&gt is the number of subsequent bases in the
primer-picking region.


<dt><a name="TARGET"><strong>Target</strong></a>
<dd>If one or more Targets is specified then a legal primer pair must
flank at least one of them.  A Target might be a simple sequence
repeat site (for example a CA repeat) or a single-base-pair
polymorphism.  The value should be a space-separated list of

<pre>
&ltstart&gt,&ltlength&gt
</pre>

pairs where &ltstart&gt is the (0-based) index of the first base of a
Target, and &ltlength&gt is its length.



<dt><a name="EXCLUDED_REGION"><strong>Excluded Region</strong></a>
<dd>Primer oligos may not overlap any region specified in this tag.
The associated value must be a space-separated list of

<pre>
&ltstart&gt,&ltlength&gt
</pre>

pairs where &ltstart&gt is the (0-based) index of the first base of
the excluded region, and &ltlength&gt is its length.  This tag is
useful for tasks such as excluding regions of low sequence
quality or for excluding regions containing repetitive elements
such as ALUs or LINEs.


<dt><a name="PRIMER_SEQUENCE_QUALITY"><strong>Sequence Quality</strong></a>
<dd>A list of space separated integers. There must be exactly one
integer for each base in SEQUENCE if this argument is non-empty.
High numbers indicate high confidence in the base call at that
position and low numbers indicate low confidence in the base
call at that position.


<dt><a name="PRIMER_LEFT_INPUT"><strong>Left Input</strong></a>
<dd>The sequence of a left primer to check and around which to design
right primers and optional internal oligos.  Must be a substring
of SEQUENCE.


<dt><a name="PRIMER_RIGHT_INPUT"><strong>Right Input</strong></a>
<dd>The sequence of a right primer to check and around which to
design left primers and optional internal oligos.  Must be a
substring of the reverse strand of SEQUENCE.


<dt><a name="PRIMER_MISPRIMING_LIBRARY"><strong>Mispriming Library</strong></a>
<dd>

This selection indicates what mispriming library (if any)
Primer3 should use to screen for interspersed repeats or
for other sequence to avoid as a location for primers.


<dt><a name="PRIMER_MAX_MISPRIMING"><strong>Max Mispriming</strong></a>
<dd>The maximum allowed weighted similarity with any sequence in
Mispriming Library.
Default is 12.


<dt><a name="PRIMER_PAIR_MAX_MISPRIMING"><strong>Pair Max Mispriming</strong></a>
<dd>The maximum allowed sum of weighted similarities of a primer pair
(one similarity for each primer) with any single sequence in
Mispriming Library.
Default is 24.


<dt><a name="PRIMER_PRODUCT_SIZE_RANGE"><strong>Product Size Range</strong></a>
<dd>The associated values specify the lengths of the product that the
user wants the primers to create, and is a space separated list
of elements of the form

<pre>
&ltx&gt-&lty&gt
</pre>

where an &ltx&gt-&lty&gt pair is a legal range of lengths for the
product.  For example, if one wants PCR products to be between
100 to 150 bases (inclusive) then one would set this parameter to
100-150.  If one desires PCR products in either the range from
100 to 150 bases or in the range from 200 to 250 bases then one
would set this parameter to 100-150 200-250.

Primer3 favors ranges to the left side of the parameter string.
Primer3 will return legal primers pairs in the first range
regardless the value of the objective function for these pairs.
Only if there are an insufficient number of primers in the first
range will Primer3 return primers in a subsequent range.


<dt><a name="PRIMER_PICK_INTERNAL_OLIGO"><strong>Pick Internal Oligo</strong></a>
<dd>If the associated value is non-0, then Primer3 will attempt to
pick an internal oligo.  Briefly, an &quotinternal oligo&quot is intended
to be used as a hybridization probe to detect the PCR product
after amplification.
Enter parameters at <a href="#Internal+Oligo+Per-Sequence+Inputs">
Internal Oligo Per-Sequence Inputs.</a>


<dt><a name="PRIMER_GC_CLAMP"><strong>CG Clamp</strong></a>
<dd>Require the specified number of consecutive Gs and Cs at the 3'
end of both the left and right primer.  (This parameter has no
effect on the internal oligo if one is requested.)


<dt><a name="PRIMER_OPT_SIZE"><strong>Optimum Primer Size</strong></a>
<dd>Optimum length (in bases) of a primer oligo. Primer3 will attempt
to pick primers close to this length.


<dt><a name="PRIMER_MIN_SIZE"><strong>Minimum Primer Size</strong></a>
<dd>Minimum acceptable length of a primer.


<dt><a name="PRIMER_MAX_SIZE"><strong>Maximum Primer Size</strong></a>
<dd>Maximum acceptable length (in bases) of a primer.  Currently this
parameter cannot be larger than 35.  This limit is governed by
maximum oligo size for which Primer3's melting-temperature is
valid.


<dt><a name="PRIMER_OPT_TM"><strong>Optimum Tm</strong></a>
<dd>Optimum melting temperature(Celsius) for a primer oligo. Primer3
will try to pick primers with melting temperatures are close to
this temperature.  The oligo melting temperature formula in
Primer3 is that given in Rychlik, Spencer and Rhoads, Nucleic
Acids Research, vol 18, num 12, pp 6409-6412 and Breslauer,
Frank, Bloeker and Marky, Proc. Natl. Acad. Sci. USA, vol 83, pp
3746-3750.  Please refer to the former paper for background
discussion.


<dt><a name="PRIMER_MIN_TM"><strong>Minimum Tm</strong></a>
<dd>Minimum acceptable melting temperature(Celsius) for a primer
oligo.


<dt><a name="PRIMER_MAX_TM"><strong>Maximum Tm</strong></a>
<dd>Maximum acceptable melting temperature(Celsius) for a primer
oligo.


<dt><a name="PRIMER_MAX_DIFF_TM"><strong>Maximum Tm Difference</strong></a>
<dd>Maximum acceptable (unsigned) difference between the melting
temperatures of the left and right primers.


<dt><a name="PRIMER_MIN_GC"><strong>Minimum GC Content</strong></a>
<dd>Minimum allowable percentage of Gs and Cs in any primer.


<dt><a name="PRIMER_MAX_GC"><strong>Maximum GC Content</strong></a>
<dd>Maximum allowable percentage of Gs and Cs in any primer generated
by Primer.


<dt><a name="PRIMER_SALT_CONC"><strong>Salt Concentration</strong></a>
<dd>The millimolar concentration of salt (usually KCl) in the PCR.
Primer3 uses this argument to calculate oligo melting
temperatures.
Default is 50.0 mM.


<dt><a name="PRIMER_DNA_CONC"><strong>Annealing Oligo Concentration</strong></a>
<dd>The nanomolar concentration of annealing oligos in the PCR.
Primer3 uses this argument to calculate oligo melting
temperatures.  The default (50nM) works well with the standard
protocol used at the Whitehead/MIT Center for Genome
Research--0.5 microliters of 20 micromolar concentration for each
primer oligo in a 20 microliter reaction with 10 nanograms
template, 0.025 units/microliter Taq polymerase in 0.1 mM each
dNTP, 1.5mM MgCl2, 50mM KCl, 10mM Tris-HCL (pH 9.3) using 35
cycles with an annealing temperature of 56 degrees Celsius.  This
parameter corresponds to 'c' in Rychlik, Spencer and Rhoads'
equation (ii) (Nucleic Acids Research, vol 18, num 12) where a
suitable value (for a lower initial concentration of template) is
&quotempirically determined&quot.  The value of this parameter is less
than the actual concentration of oligos in the reaction because
it is the concentration of annealing oligos, which in turn
depends on the amount of template (including PCR product) in a
given cycle.  This concentration increases a great deal during a
PCR; fortunately PCR seems quite robust for a variety of oligo
melting temperatures.



<dt><a name="PRIMER_NUM_NS_ACCEPTED"><strong>Maximum Ns Accepted</strong></a>
<dd>Maximum number of unknown bases (N) allowable in any primer.


<dt><a name="PRIMER_SELF_ANY"><strong>Maximum Complementarity</strong></a>
<dd>The maximum allowable local alignment score when testing a single
primer for (local) self-complementarity and the maximum allowable
local alignment score when testing for complementarity between
left and right primers.  Local self-complementarity is taken to
predict the tendency of primers to anneal to each other without
necessarily causing self-priming in the PCR.  The scoring system
gives 1.00 for complementary bases, -0.25 for a match of any base
(or N) with an N, -1.00 for a mismatch, and -2.00 for a gap.
Only single-base-pair gaps are allowed.  For example, the
alignment

<pre>
5' ATCGNA 3'
   || | |
3' TA-CGT 5'
</pre>

is allowed (and yields a score of 1.75), but the alignment

<pre>
5' ATCCGNA 3'
   ||  | |
3' TA--CGT 5'
</pre>

is not considered.  Scores are non-negative, and a score of 0.00
indicates that there is no reasonable local alignment between two
oligos.


<dt><a name="PRIMER_SELF_END"><strong>Maximum 3' Complementarity</strong></a>
<dd>The maximum allowable 3'-anchored global alignment score when
testing a single primer for self-complementarity, and the maximum
allowable 3'-anchored global alignment score when testing for
complementarity between left and right primers.  The 3'-anchored
global alignment score is taken to predict the likelihood of
PCR-priming primer-dimers, for example

<pre>
5' ATGCCCTAGCTTCCGGATG 3'
             ||| |||||
          3' AAGTCCTACATTTAGCCTAGT 5'
</pre>

or

<pre>
5` AGGCTATGGGCCTCGCGA 3'
               ||||||
            3' AGCGCTCCGGGTATCGGA 5'
</pre>

The scoring system is as for the Maximum Complementarity
argument.  In the examples above the scores are 7.00 and 6.00
respectively.  Scores are non-negative, and a score of 0.00
indicates that there is no reasonable 3'-anchored global
alignment between two oligos.  In order to estimate 3'-anchored
global alignments for candidate primers and primer pairs, Primer
assumes that the sequence from which to choose primers is
presented 5'-&gt3'.  It is nonsensical to provide a larger value
for this parameter than for the Maximum (local) Complementarity
parameter because the score of a local alignment will always be at
least as great as the score of a global alignment.


<dt><a name="PRIMER_MAX_POLY_X"><strong>Maximum Poly-X</strong></a>
<dd>The maximum allowable length of a mononucleotide repeat,
for example AAAAAA.


<dt><a name="PRIMER_LIBERAL_BASE"><strong>Liberal Base</strong></a>
<dd>This parameter provides a quick-and-dirty way to get Primer3 to
accept IUB / IUPAC codes for ambiguous bases (i.e. by changing
all unrecognized bases to N).  If you wish to include an
ambiguous
base in an oligo, you must set
<a href=#PRIMER_NUM_NS_ACCEPTED>Maximum Ns Accepted</a> to a
non-0 value.

Perhaps '-' and '* ' should be squeezed out rather than changed
to 'N', but currently they simply get converted to N's.  The authors
invite user comments.


<dt><a name="PRIMER_NUM_RETURN"><strong>Number To Return</strong></a>
<dd>The maximum number of primer pairs to return.  Primer pairs
returned are sorted by their &quotquality&quot, in other words by the
value of the objective function (where a lower number indicates a
better primer pair).  Caution: setting this parameter to a large
value will increase running time.


<dt><a name="PRIMER_FIRST_BASE_INDEX"><strong>First Base Index</strong></a>
<dd>This parameter is the index of the first base in the input
sequence.  For input and output using 1-based indexing (such as
that used in GenBank and to which many users are accustomed) set
this parameter to 1.  For input and output using 0-based indexing
set this parameter to 0.  (This parameter also affects the
indexes in the contents of the files produced when the primer
file flag is set.)
In the WWW interface this parameter defaults to 1.


<dt><a name="PRIMER_MIN_QUALITY"><strong>Min Quality</strong></a>
<dd>The minimum sequence quality (as specified by
PRIMER_SEQUENCE_QUALITY) allowed within a primer.


<dt><a name="PRIMER_MIN_END_QUALITY"><strong>Min End Quality</strong></a>
<dd>The minimum sequence quality (as specified by
PRIMER_SEQUENCE_QUALITY) allowed within the 5' pentamer of a
primer.


<dt><a name="PRIMER_QUALITY_RANGE_MIN"><strong>Quality Range Min</strong></a>
<dd>The minimum legal sequence quality (used for error checking
of PRIMER_MIN_QUALITY and PRIMER_MIN_END_QUALITY).


<dt><a name="PRIMER_QUALITY_RANGE_MAX"><strong>Quality Range Max</strong></a>
<dd>The maximum legal sequence quality (used for error checking
of PRIMER_MIN_QUALITY and PRIMER_MIN_END_QUALITY).


<dt><a name="PRIMER_INSIDE_PENALTY"><strong>Inside Penalty</strong></a>
<dd>This experimental parameter might not be maintained in this form
in the next release.  Non-default values valid only for sequences
with 0 or 1 target regions.  If the primer is part of a pair that
spans a target and overlaps the target, then multiply this value
times the number of nucleotide positions by which the primer
overlaps the (unique) target to get the 'position penalty'.  The
effect of this parameter is to allow Primer3 to include overlap
with the target as a term in the objective function.


<dt><a name="PRIMER_OUTSIDE_PENALTY"><strong>Outside Penalty</strong></a>
<dd>This experimental parameter might not be maintained in this form
in the next release.  Non-default values valid only for sequences
with 0 or 1 target regions.  If the primer is part of a pair that
spans a target and does not overlap the target, then multiply
this value times the number of nucleotide positions from the 3'
end to the (unique) target to get the 'position penalty'.
The effect of this parameter is to allow Primer3 to include
nearness to the target as a term in the objective function.


<dt><a name="PRIMER_MAX_END_STABILITY"><strong>Max End Stability</strong></a>
<dd>The maximum stability for the five 3' bases of a left or right
primer.  Bigger numbers mean more stable 3' ends.  The value is
the maximum delta G for duplex disruption for the five 3' bases
as calculated using the nearest neighbor parameters published in
Breslauer, Frank, Bloeker and Marky, Proc. Natl. Acad. Sci. USA,
vol 83, pp 3746-3750.  Primer3 uses a completely permissive
default value for backward compatibility (which we may change in
the next release).  Rychlik recommends a maximum value of 9
(Wojciech Rychlik, &quotSelection of Primers for Polymerase Chain
Reaction&quot in BA White, Ed., &quotMethods in Molecular Biology,
Vol. 15: PCR Protocols: Current Methods and Applications&quot, 1993,
pp 31-40, Humana Press, Totowa NJ).



</dl>


</form>

<h2><a name="internal_oligo_generic">Internal Oligos</a></h2>

Parameters governing choice of internal
oligos are analogous to the parameters governing
choice of primer pairs.
The exception is Maximum 3' Complementarity
which is meaningless when applied
to internal oligos used for hybridization-based detection, since
primer-dimer will not occur.  We recommend that Maximum 3' Complementarity
be set at least as high as Maximum Complementarity.

<h2><a name="cannot_find">What if no primers are found?</a></h2>
Try relaxing various parameters, including the
self-complementarity parameters and max and min oligo melting
temperatures.  For example, for very A-T-rich regions you might
have to increase maximum primer size or decrease minimum melting
temperature.  It is usually unwise to reduce the minimum primer
size if your template is complex (e.g. a mammalian genome), since
small primers are more likely to be non-specific.  Make sure that
there are adequate stretches of non-Ns in the regions in which
you wish to pick primers.  If necessary you can also allow an N
in your primer and use an oligo mixture containing all four bases
at that position.


<h2><a name="cautions">Cautions</a></h2>
Some of the most important issues in primer picking can be
addressed only in Primer3's input.  These are sequence quality
(including making sure the sequence is not vector and not
chimeric) and avoiding repetitive elements.
<p>

Techniques for avoiding problems include a thorough understanding
of possible vector contaminants and cloning artifacts coupled
with database searches using blast, fasta, or other similarity
searching program to screen for vector contaminants and possible
repeats.  Repbase (J. Jurka, A.F.A. Smit, C. Pethiyagoda, and
others, 1995-1996, <a href="ftp://ncbi.nlm.nih.gov/repository/repbase">ftp://ncbi.nlm.nih.gov/repository/</a>)
is an excellent source of repeat sequences and pointers to the
literature.  Primer3 now allows you to screen candidate oligos
against a a Mispriming Library (or a Mishyb Library in the case
of internal oligos).
<p>

Sequence quality can be controlled by manual trace viewing and
quality clipping or automatic quality clipping programs.  Low-
quality bases should be changed to N's or can be made part of
Excluded Regions. The beginning of a sequencing read is often
problematic because of primer peaks, and the end of the read
often contains many low-quality or even meaningless called bases.
When picking primers from single-pass sequence it is often best
to avoid the first 20 base pairs, and to prefer shorter product
sizes or shortened Included Region lengths to avoid low-quality
sequence at the end of the sequence read.  In addition, Primer3
takes as input a Sequence Quality list for use with those base
calling programs such as Phred 
<a href="http://www.mbt.washington.edu/phrap_documentation.html">
(http://www.mbt.washington.edu/phrap_documentation.html)</a>
Bass/Grace, and Trout that provide
this output.





<h2><a name="disclaimer">Copyright Notice and Disclaimer</a></h2>
<pre>
$Copyright
</pre>
<h2>Acknowledgements</h2>
The development of Primer3 and the Primer3
web site was funded by 
<a href="http://www.hhmi.org/">Howard Hughes Medical Institute</a>
and by the 
<a href="http://www.nih.gov/">National Institutes of Health,</a>
<a href="http://www.nchgr.nih.gov/">
National Center for Human Genome Research.</a>
under grants R01-HG00257
(to David C. Page) and P50-HG00098 (to Eric S. Lander).
<p>
We gratefully acknowledge the support of
<a href="http://www.dec.com/">
Digital Equipment Corporation,</a>
which provided the Alphas which were used for much
of the development of Primer3, and of 
Centerline Software, Inc.,
whose TestCenter memory-error, -leak, and test-coverage checker
helped us discover and correct a number of otherwise latent
errors in Primer3.
<p>
<hr>
Original design of this primer-picking web site
by <em>Richard Resnick</em>, who
also is an author of this site's documentation.
Web software provided by
<em><a href="http://www.genome.wi.mit.edu/~steve">Steve Rozen</a></em>
<a href="mailto:steve\@genome.wi.mit.edu">steve\@genome.wi.mit.edu</a>
and <a href="http://www.genome.wi.mit.edu">
Whitehead Institute/MIT Center for Genome Research.</a>
<hr>
This page is maintained by $MAINTAINER.
<pre>$cgi_version</pre>
};

    print $query->end_html;
    print "\n";
}
